dnl
dnl  libflame
dnl  An object-based infrastructure for developing high-performance
dnl  dense linear algebra libraries.
dnl
dnl  Copyright (C) 2008, The University of Texas
dnl
dnl  libflame is free software; you can redistribute it and/or modify
dnl  it under the terms of the GNU Lesser General Public License as
dnl  published by the Free Software Foundation; either version 2.1 of
dnl  the License, or (at your option) any later version.
dnl
dnl  libflame is distributed in the hope that it will be useful, but
dnl  WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
dnl  Lesser General Public License for more details.
dnl
dnl  You should have received a copy of the GNU Lesser General Public
dnl  License along with libflame; if you did not receive a copy, see
dnl  http://www.gnu.org/licenses/.
dnl
dnl  For more information, please contact us at flame@cs.utexas.edu or
dnl  send mail to:
dnl
dnl  Field G. Van Zee and/or
dnl  Robert A. van de Geijn
dnl  The University of Texas at Austin
dnl  Department of Computer Sciences
dnl  1 University Station C0500
dnl  Austin TX 78712
dnl
AC_DEFUN([FLA_REQUIRE_F77],
[
	AC_REQUIRE([FLA_OBSERVE_HOST_CPU_TYPE])

	dnl Save the value of FFLAGS. This will come in useful later in determining
	dnl whether the user provided his own definition of FFLAGS.
	fla_userdef_fflags=$FFLAGS

	dnl Check for Fortran-77 compiler. Default search order is F77 environment 
	dnl variable, then g77, then f77, then some other Fortran compilers.
	AC_PROG_F77([$fla_requested_f77 $fla_f77_compiler_list])

	if test "$F77" = "" ; then
		AC_MSG_ERROR([Could not locate any of the following Fortran 77 compilers: $F77 $fla_requested_f77 $fla_f77_compiler_list. Cannot continue without a Fortran 77 compiler.],[1])
	fi
	
	dnl Substitute the user-defined FFLAGS into the autoconf output files.
	AC_SUBST(fla_userdef_fflags)
])
