#!/bin/bash

# The install prefix specifies the root directory of the installation.
export FLAME_INSTALL_PREFIX=$HOME/flame

# Override the default compiler search order and default compiler flags.
#export CC=gcc
#export F77=gfortran
#export CC=icc
#export F77=ifort

# Run configure.
./configure --prefix=${FLAME_INSTALL_PREFIX} \
            --disable-verbose-make-output \
            --enable-non-critical-code \
            --enable-builtin-lapack-routines \
            --enable-blas3-front-end-cntl-trees \
            --disable-windows-build \
            --disable-plapack2e \
            --enable-multithreading=pthreads \
            --enable-supermatrix \
            --disable-supermatrix-visualization \
            --disable-cell-spu-parallelism \
            --disable-memory-alignment \
            --disable-ldim-alignment \
            --enable-optimizations \
            --enable-warnings \
            --enable-debug \
            --disable-profiling \
            --enable-internal-error-checking \
            --enable-memory-counter \
            --disable-goto-interfaces \
            --disable-cblas-interface \
            --disable-portable-timer

