/*
   libflame
   An object-based infrastructure for developing high-performance
   dense linear algebra libraries.

   Copyright (C) 2008, The University of Texas

   libflame is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 2.1 of
   the License, or (at your option) any later version.

   libflame is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with libflame; if you did not receive a copy, see
   http://www.gnu.org/licenses/.

   For more information, please contact us at flame@cs.utexas.edu or
   send mail to:

   Field G. Van Zee and/or
   Robert A. van de Geijn
   The University of Texas at Austin
   Department of Computer Sciences
   1 University Station C0500
   Austin TX 78712
*/

// Built-in LAPACK routines
#define cgehd2 CGEHD2
#define cgehrd CGEHRD
#define cgelq2 CGELQ2
#define cgelqf CGELQF
#define cgeqr2 CGEQR2
#define cgeqrf CGEQRF
#define cgetf2 CGETF2
#define cgetrf CGETRF
#define claset CLASET
#define claswp CLASWP
#define clarfg CLARFG
#define clarft CLARFT
#define clauu2 CLAUU2
#define clauum CLAUUM
#define cpotf2 CPOTF2
#define cpotrf CPOTRF
#define ctrsyl CTRSYL
#define ctrti2 CTRTI2
#define ctrtri CTRTRI
#define dgehd2 DGEHD2
#define dgehrd DGEHRD
#define dgelq2 DGELQ2
#define dgelqf DGELQF
#define dgeqr2 DGEQR2
#define dgeqrf DGEQRF
#define dgetf2 DGETF2
#define dgetrf DGETRF
#define dlaset DLASET
#define dlaswp DLASWP
#define dlarfg DLARFG
#define dlarft DLARFT
#define dlauu2 DLAUU2
#define dlauum DLAUUM
#define dpotf2 DPOTF2
#define dpotrf DPOTRF
#define dtrsyl DTRSYL
#define dtrti2 DTRTI2
#define dtrtri DTRTRI
#define sgehd2 SGEHD2
#define sgehrd SGEHRD
#define sgelq2 SGELQ2
#define sgelqf SGELQF
#define sgeqr2 SGEQR2
#define sgeqrf SGEQRF
#define sgetf2 SGETF2
#define sgetrf SGETRF
#define slaset SLASET
#define slaswp SLASWP
#define slarfg SLARFG
#define slarft SLARFT
#define slauu2 SLAUU2
#define slauum SLAUUM
#define spotf2 SPOTF2
#define spotrf SPOTRF
#define strsyl STRSYL
#define strti2 STRTI2
#define strtri STRTRI
#define zgehd2 ZGEHD2
#define zgehrd ZGEHRD
#define zgelq2 ZGELQ2
#define zgelqf ZGELQF
#define zgeqr2 ZGEQR2
#define zgeqrf ZGEQRF
#define zgetf2 ZGETF2
#define zgetrf ZGETRF
#define zlaset ZLASET
#define zlaswp ZLASWP
#define zlarfg ZLARFG
#define zlarft ZLARFT
#define zlauu2 ZLAUU2
#define zlauum ZLAUUM
#define zpotf2 ZPOTF2
#define zpotrf ZPOTRF
#define ztrsyl ZTRSYL
#define ztrti2 ZTRTI2
#define ztrtri ZTRTRI
