/*
   libflame
   An object-based infrastructure for developing high-performance
   dense linear algebra libraries.

   Copyright (C) 2008, The University of Texas

   libflame is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 2.1 of
   the License, or (at your option) any later version.

   libflame is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with libflame; if you did not receive a copy, see
   http://www.gnu.org/licenses/.

   For more information, please contact us at flame@cs.utexas.edu or
   send mail to:

   Field G. Van Zee and/or
   Robert A. van de Geijn
   The University of Texas at Austin
   Department of Computer Sciences
   1 University Station C0500
   Austin TX 78712
*/

#include "FLAME.h"

FLA_Error FLA_Apply_USU( FLA_Side side, FLA_Uplo uplo, FLA_Trans transa, FLA_Obj A, FLA_Obj S, FLA_Obj B );
FLA_Error FLA_Apply_USU_internal( FLA_Side side, FLA_Uplo uplo, FLA_Trans transa, FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );

FLA_Error FLA_Apply_USU_lln_blk_var1( FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );
FLA_Error FLA_Apply_USU_llt_blk_var1( FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );
FLA_Error FLA_Apply_USU_lun_blk_var1( FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );
FLA_Error FLA_Apply_USU_lut_blk_var1( FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );
FLA_Error FLA_Apply_USU_rln_blk_var1( FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );
FLA_Error FLA_Apply_USU_rlt_blk_var1( FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );
FLA_Error FLA_Apply_USU_run_blk_var1( FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );
FLA_Error FLA_Apply_USU_rut_blk_var1( FLA_Obj A, FLA_Obj S, FLA_Obj B, int nb_alg );

void FLA_F2C( fla_apply_usu_f             )( F_INT *side, F_INT *uplo, F_INT *transa, F_INT *A, F_INT *S, F_INT *B, F_INT *IERROR );
void FLA_F2C( fla_apply_usu_lln_blk_var1_f )( F_INT *A, F_INT *S, F_INT *B, F_INT *nb_alg, F_INT *IERROR );
void FLA_F2C( fla_apply_usu_llt_blk_var1_f )( F_INT *A, F_INT *S, F_INT *B, F_INT *nb_alg, F_INT *IERROR );
void FLA_F2C( fla_apply_usu_lun_blk_var1_f )( F_INT *A, F_INT *S, F_INT *B, F_INT *nb_alg, F_INT *IERROR );
void FLA_F2C( fla_apply_usu_lut_blk_var1_f )( F_INT *A, F_INT *S, F_INT *B, F_INT *nb_alg, F_INT *IERROR );
void FLA_F2C( fla_apply_usu_rln_blk_var1_f )( F_INT *A, F_INT *S, F_INT *B, F_INT *nb_alg, F_INT *IERROR );
void FLA_F2C( fla_apply_usu_rlt_blk_var1_f )( F_INT *A, F_INT *S, F_INT *B, F_INT *nb_alg, F_INT *IERROR );
void FLA_F2C( fla_apply_usu_run_blk_var1_f )( F_INT *A, F_INT *S, F_INT *B, F_INT *nb_alg, F_INT *IERROR );
void FLA_F2C( fla_apply_usu_rut_blk_var1_f )( F_INT *A, F_INT *S, F_INT *B, F_INT *nb_alg, F_INT *IERROR );
