#include "FLAME.h"

int FLA_LU_2x2( int reuse_B, 
		FLA_Obj B, FLA_Obj C,
		FLA_Obj D, FLA_Obj E, 
                FLA_Obj p_B, FLA_Obj p_D, FLA_Obj p_E,
		FLA_Obj L, int nb_alg )
{
  
  if ( !reuse_B && FLA_Obj_length( B ) != 0)
    FLA_LU_piv( B, p_B );

  if ( FLA_Obj_length( E ) != 0){
    FLA_Apply_pivots( FLA_LEFT, FLA_NO_TRANSPOSE, p_B, C );

    FLA_Trsm( FLA_LEFT, FLA_LOWER_TRIANGULAR, FLA_NO_TRANSPOSE, FLA_UNIT_DIAG,
    	      FLA_ONE, B, C );

    FLA_LU_SA_LIN_blk( B,
    		       D, p_D, L, nb_alg );

    FLA_FS_SA_LIN_blk( L, 
      	               D, p_D, C, 
    		               E, nb_alg );

    FLA_LU_piv( E, p_E );
  }
   
  return FLA_SUCCESS;
}

  
