/*
Copyright (C) 2002 the University of Texas at Austin (U. T. Austin)

Submit software operation questions to: Robert van de Geijn,
Department of Computer Sciences,U. T. Austin, Austin, Texas 78712
(rvdg@cs.utexas.edu).

Submit commercialization requests to: Office of the Executive Vice
President and Provost, U. T. Austin, 201 Main Bldg., Austin, Texas,
78712, ATTN: Technology Licensing Specialist.
*/
#include "FLAME.h"

int FLA_Block( FLA_Obj A, int T, int M, int N, FLA_Obj **As )
{
  FLA_Obj     AL, AR,   A0, A1, A2,
              AT1,   A01,
                     A11,
              AB1,   A21,   *Acur;
  

  *As = Acur = ( FLA_Obj * ) FLA_malloc( ( size_t ) ( M * N * sizeof( FLA_Obj ) ) );

  FLA_Part_1x2( A,  &AL, /**/ &AR,  0, FLA_LEFT );

  while ( 0 != FLA_Obj_width( AR ) ){
    FLA_Repart_1x2_to_1x3( AL,  /**/ AR,        &A0,  /**/ &A1,  &A2,
			   T, /* A1 split from */ FLA_RIGHT );

    FLA_Part_2x1( A1, &AT1,
		      &AB1, 0, FLA_TOP );

    while ( 0 != FLA_Obj_length( AB1 ) ){

      FLA_Repart_2x1_to_3x1( AT1,                 &A01,
 		          /* *** */             /* *** */
			                          Acur,
			     AB1,                 &A21,      
                             T, /* length A11 split from */ FLA_BOTTOM );

      FLA_Cont_with_3x1_to_2x1( &AT1,                  A01,
		                                       *Acur,
                              /* *** */             /* ***** */
				&AB1,                  A21, 
                              /* with *Acur added to */ FLA_TOP );
      Acur++;
    }

    FLA_Cont_with_1x3_to_1x2( &AL,  /**/ &AR,        A0,  A1,  /**/ A2,
			      /* with A1 added to */ FLA_LEFT );
  }

  return FLA_SUCCESS;
}

