/*
Copyright (C) 2002 the University of Texas at Austin (U. T. Austin)

Submit software operation questions to: Robert van de Geijn,
Department of Computer Sciences,U. T. Austin, Austin, Texas 78712
(rvdg@cs.utexas.edu).

Submit commercialization requests to: Office of the Executive Vice
President and Provost, U. T. Austin, 201 Main Bldg., Austin, Texas,
78712, ATTN: Technology Licensing Specialist.
*/
#include "FLAME.h"

#define dabs( x ) ( (x)<0 ? -(x) : (x) )

int FLA_LU_inc_panel_unb( FLA_Obj AT,
			  FLA_Obj AB, FLA_Obj ipiv )
{
  int 
    n, mB, curn, i_one=1, ldim_AT, ldim_AB, j, ipivot,
    *buff_ipiv;
  double 
    aii_inv, d_minus_one=-1.0,
    *buff_AT, *buff_AB;

  n = FLA_Obj_width( AT );
  mB = FLA_Obj_length( AB );
  curn = n;
  buff_AT = ( double * ) FLA_Obj_buffer( AT );
  buff_AB = ( double * ) FLA_Obj_buffer( AB );
  buff_ipiv = ( int * ) FLA_Obj_buffer( ipiv );
  ldim_AT = FLA_Obj_ldim( AT );
  ldim_AB = FLA_Obj_ldim( AB );

  for ( j=0; j<n; j++ ){
    ipivot = cblas_idamax( mB, &buff_AT[ j*ldim_AB ], i_one ) - 1;
    if ( dabs( buff_AB[ j*ldim_AB + ipivot ] ) <
	 dabs( buff_AT[ j*ldim_AT + j ] ) ){
      cblas_dswap( n, buff_AT+j, ldim_AT, buff_AB+j, ldim_AB );
    }
    else
      ipivot = -1;

    aii_inv = 1.0/buff_AT[ j*ldim_AT+j ];
    cblas_dscal( mB, aii_inv, buff_AB+j*ldim_AB, i_one );

    cblas_dger( CblasColMajor, mB, curn, 
		d_minus_one, buff_AB+j*ldim_AB, i_one, 
		buff_AT+(j+1)*ldim_AT+j, ldim_AT, 
		buff_AB+(j+1)*ldim_AB, ldim_AB );

    *( buff_ipiv + j ) = ipivot;
    curn--;
  }
}
