/*
Copyright (C) 2002 the University of Texas at Austin (U. T. Austin)

Submit software operation questions to: Robert van de Geijn,
Department of Computer Sciences,U. T. Austin, Austin, Texas 78712
(rvdg@cs.utexas.edu).

Submit commercialization requests to: Office of the Executive Vice
President and Provost, U. T. Austin, 201 Main Bldg., Austin, Texas,
78712, ATTN: Technology Licensing Specialist.
*/
#include "FLAME.h"

int FLA_LU_inc_pivot_rest( FLA_Obj AT,
			   FLA_Obj AB, FLA_Obj ipiv )
{
  int
    m, n;
  FLA_Obj A_copy, AT_copy, AB_copy;

  m = FLA_Obj_length( AT ) + FLA_Obj_length( AB );
  n = FLA_Obj_width( AT );

  FLA_Obj_create( FLA_DOUBLE, m, n, &A_copy );
  FLA_Part_2x1( A_copy, &AT_copy,
		        &AB_copy, FLA_Obj_length( AT ), FLA_TOP );

  FLA_Copy( AT, AT_copy );
  FLA_Copy( AB, AB_copy );

  FLA_Apply_pivots( FLA_LEFT, FLA_NO_TRANSPOSE, ipiv, A_copy );

  FLA_Copy( AT_copy, AT );
  FLA_Copy( AB_copy, AB );

  FLA_Obj_free( &A_copy );
}

