#
# make include file for LAPACK test suite.
# (derived from make.inc from LAPACK v3.0,
#  modified to reference the FLAME makefile system)
# 
# Field G. Van Zee
#


#
# Include the definitions from the main project
#

include $(BASE_DIST_PATH)/build/common.mk


#
# Use bourne shell for our scripts.
#

SHELL     := /bin/sh


#  
# Modify the FORTRAN and OPTS definitions to refer to the
# compiler and desired compiler options for your machine.  NOOPT
# refers to the compiler options desired when NO OPTIMIZATION is
# selected.  Define LOADER and LOADOPTS to refer to the loader and 
# desired load options for your machine.
#

FORTRAN   := $(FC)       # g77
OPTS      := $(FFLAGS)   # -O3 -funroll-loops
DRVOPTS   := $(OPTS)     # 
NOOPT     :=             # 
LOADER    := $(FORTRAN)  # 
LOADOPTS  :=             # 


#
# The archiver and the flag(s) to use when building archive (library)
# If you system has no ranlib, set RANLIB = echo.
#

ARCH      := $(AR)
ARCHFLAGS := cr
RANLIB    := ranlib


#
# These are the libraries to which the test routines will link.
#
# Here, BASE_DIST_PATH is the path to the flame repository branch from which
# 'make test' was typed. Each MK*LIB variable is the relative path from the
# top-level make directory to the actualy library archive.
#
BLASLIB   := $(REF_BLAS_LIB)
LAPACKLIB := $(BASE_DIST_PATH)/$(MK_LAPACK_LAPACK2FLAMEC_LIB) \
             $(BASE_DIST_PATH)/$(MK_LAPACK_FLAMEC_LIB) \
             $(BASE_DIST_PATH)/$(MK_BASE_FLAMEC_LIB) \
             $(REF_LAPACK_LIB)
TMGLIB    := tmglib.a
#EIGSRCLIB := eigsrc.a
#LINSRCLIB := linsrc.a

